// -*- C++ -*-
/*!
 * @file RtcFactory.h
 * @brief RT component manager class
 * @date $Date$
 *
 * Copyright (c) 2003-2004 Noriaki Ando <n-ando@aist.go.jp>
 *          Task-intelligence Research Group,
 *          Intelligent System Research Institute,
 *          National Institute of Industrial Science (AIST),
 *          Japan. All rights reserved.
 *
 * $Id$
 */


#include "rtm/RtcBase.h"
#include "rtm/RtcModuleProfile.h"
#include "rtm/RtcManager.h"
#include "rtm/RtcFactory.h"

namespace RTM 
{


  RtcFactoryCXX::RtcFactoryCXX(RtcModuleProfile profile,
			       RtcNewFunc new_func,
			       RtcDeleteFunc delete_func)
    : RtcFactoryBase(profile), m_New(new_func), m_Delete(delete_func)
  {
  }


  RtcBase* RtcFactoryCXX::create(RtcManager* mgr)
  {
    ++m_Number;
    return m_New(mgr);
  }

  void RtcFactoryCXX::destroy(RtcBase* comp)
  {
    m_Delete(comp);
  }

};

