/*
 *
 * Copyright(C) Isao Hara, 2006.
 *
 */

#include <stdio.h>
#include "Rtc_DLL.h"

RTC_DLL_Handle::RTC_DLL_Handle(char *dll_name, int mode, int x):
   refcount_(0),dll_name_(0), handle_(0)
{
  this->open(dll_name,  mode, 0);
}

char *RTC_DLL_Handle::dll_name() const{
  return this->dll_name_;
}

int RTC_DLL_Handle::open(const char *dll_name, int mode, void *handle){
  if(this->dll_name_ && strcmp(this->dll_name_, dll_name)){
     this->error_ = "DLL_Handle::open: invalid dll_name";
     return -1;
  }

  this->dll_name_  = strdup(dll_name);

  if(this->handle_ == 0){
    if(handle) this->handle_ = handle;
    else{
      if((this->handle_ = dlopen(dll_name, mode)) == 0){
         this->error_ = dlerror();
	 return -1;
      }
    }
  }else if(this->handle_ != handle){
     this->error_ = "DLL_Handle::open: invalid handle ";
     return -1;
  }

  dlerror();
  this->refcount_ += 1;
  return this->refcount_;

}

int RTC_DLL_Handle::close(int unload){
  int res=0;
  if( this->refcount_ > 0) this->refcount_ -= 1;

  if(this->refcount_ == 0 && this->handle_ != 0 && unload == 1){
    res = dlclose(this->handle_);
    this->handle_ = 0;
  }

   return res;
}

int RTC_DLL_Handle::refcount() const{
  return this->refcount_;
}

void* RTC_DLL_Handle::symbol(const char *sym_name){
  void *func = (void *)0;

  dlerror();
  *(void **)(&func) = dlsym(this->handle_, sym_name);
  if((this->error_ = dlerror()) != NULL){
    return (void *)NULL;
  }

  return func;
}

void* RTC_DLL_Handle::get_handle(){
	return this->handle_;
}

