/*
 *
 * Copyright(C) Isao Hara, 2006.
 *
 */

#ifndef __RTC_DLL_H__
#define __RTC_DLL_H__

#include <dlfcn.h>
#include <string.h>

/****
 * RTC_DLL_Handle
 */
class RTC_DLL_Handle{
  int refcount_;
  char *dll_name_;
  void *handle_;
  char *error_;

public:
  RTC_DLL_Handle() : refcount_(0),dll_name_(0), handle_(0){ }
  RTC_DLL_Handle(char *, int, int);

  ~RTC_DLL_Handle(){
    this->close(1);
    delete [] this->dll_name_;
  }

  char* dll_name() const;
  int open(const char* dll_name, int mode=RTLD_LAZY, void *handle=0);
  int close(int);
  int refcount() const;
  void *symbol(const char *sym_name);
  void *get_handle();

};

#endif
