/*
 *
 */

#include "Rtc_Mutex.h"


RTC_Thread_Mutex::RTC_Thread_Mutex(){
//    pthread_mutexattr_init(&this->_attr);
//    pthread_mutexattr_settype(&this->_attr, PTHREAD_MUTEX_RECURSIVE_NP);
//    pthread_mutex_init(&this->_m, &this->_attr);
    pthread_mutex_init(&this->_m, 0);
}

RTC_Thread_Mutex::~RTC_Thread_Mutex(){
    pthread_mutex_destroy(&this->_m);
}

void RTC_Thread_Mutex::Lock(){
    pthread_mutex_lock(&this->_m);
}

void RTC_Thread_Mutex::UnLock(){
    pthread_mutex_unlock(&this->_m);
}

void RTC_Thread_Mutex::acquire(){
    pthread_mutex_lock(&this->_m);
}

int RTC_Thread_Mutex::tryacquire_write(){
    return   pthread_mutex_trylock(&this->_m);
}

int RTC_Thread_Mutex::tryacquire(){
    return pthread_mutex_trylock(&this->_m);
}

void RTC_Thread_Mutex::release(){
    pthread_mutex_unlock(&this->_m);
}

pthread_mutex_t *RTC_Thread_Mutex::mutex(){
    return &this->_m;
}
////////////////
template <class MUTEX>
RTC_Guard<MUTEX>::RTC_Guard(MUTEX& m) : _m(m)
{
   _m.Lock();
}

template <class MUTEX>
RTC_Guard<MUTEX>::~RTC_Guard()
{
   _m.UnLock();
}
////////////////
template <class MUTEX>
RTC_Condition<MUTEX>::RTC_Condition(MUTEX& m) : _m(m)
{
    pthread_cond_init(&this->_cond, 0);
}

template <class MUTEX>
RTC_Condition<MUTEX>::~RTC_Condition() 
{
  this->remove();
}

template <class MUTEX> int
RTC_Condition<MUTEX>::signal() 
{
    pthread_cond_signal(&this->_cond);
}

template <class MUTEX> int
RTC_Condition<MUTEX>::wait() 
{
   pthread_mutex_t *mutex = this->_m.mutex();
   pthread_cond_wait(&this->_cond, mutex);
}

template <class MUTEX> int
RTC_Condition<MUTEX>::wait(const struct timespec *abstime) 
{
   pthread_mutex_t *mutex = this->_m.mutex();
   pthread_cond_timedwait(&this->_cond, mutex, abstime);
}

template <class MUTEX> int
RTC_Condition<MUTEX>::broadcast() 
{
    pthread_cond_broadcast(&this->_cond);
}

template <class MUTEX> int
RTC_Condition<MUTEX>::remove() 
{
    pthread_cond_broadcast(&this->_cond);
    pthread_cond_destroy(&this->_cond);
}

template <class MUTEX> MUTEX&
RTC_Condition<MUTEX>::mutex() 
{
  return _m;
}

////////////////// Implementation
int RTC_Condition<RTC_Thread_Mutex>::signal(){
    return pthread_cond_signal(&this->_cond);
}

RTC_Condition<RTC_Thread_Mutex>::~RTC_Condition(){
  this->remove();
}

RTC_Condition<RTC_Thread_Mutex>::RTC_Condition(RTC_Thread_Mutex& m) : _m(m){
    pthread_cond_init(&this->_cond, 0);
}

int RTC_Condition<RTC_Thread_Mutex>::wait(){
   pthread_mutex_t *mutex = this->_m.mutex();
   return pthread_cond_wait(&this->_cond, mutex);
}

RTC_Guard<RTC_Thread_Mutex>::RTC_Guard(RTC_Thread_Mutex& m) : _m(m){
   _m.Lock();
}
RTC_Guard<RTC_Thread_Mutex>::~RTC_Guard(){
   _m.UnLock();
}

