/*
 *
 */

#ifndef __RTC_THREAD_H__
#define __RTC_THREAD_H__

#include <pthread.h>


class RTC_Thread_Mutex{
  pthread_mutexattr_t _attr;
  pthread_mutex_t _m;
public:

  RTC_Thread_Mutex();
  ~RTC_Thread_Mutex();
  void Lock();
  void UnLock();
  void acquire();
  int tryacquire_write();
  int tryacquire();
  void release();
  pthread_mutex_t *mutex();
};

template <class MUTEX> class RTC_Guard {
 MUTEX& _m;
public:
  RTC_Guard(MUTEX& m) ;
  ~RTC_Guard() ;
};

template <class MUTEX> class RTC_Condition {
protected:
 MUTEX& _m;
 pthread_cond_t _cond;

public:

  RTC_Condition(MUTEX& m) ;
  ~RTC_Condition();
  int signal();
  int wait();
  int wait(const struct timespec *abstime);
  int broadcast();
  int remove();
  MUTEX &mutex();
};

#endif
