

#include "Rtc_Signal.h"


RTC_Sig_Action::RTC_Sig_Action() :
  _handle(0), _signum(0), _mask(0), _flags(0)
{

}

RTC_Sig_Action::RTC_Sig_Action(RTC_SignalHandler handle, int signum, sigset_t *sigmask,int flags) : 
  _handle(handle), _signum(signum), _mask(sigmask), _flags(flags)
{
  int i;
  struct sigaction act;

  act.sa_handler = handle;

  if (sigmask) act.sa_mask = *sigmask;
  else for(i=0;i<_SIGSET_NWORDS;i++) act.sa_mask.__val[i] = 0;
  act.sa_flags = flags;

  signal(this->_signum, SIG_IGN);
  if(sigaction(this->_signum, &act, 0) < 0){
    signal(this->_signum, SIG_DFL);
    this->_handle=0;
    this->_signum=0;
    this->_mask=0;
    this->_flags=0;
  }
}

RTC_Sig_Action::~RTC_Sig_Action()
{
  signal(this->_signum, SIG_DFL);
  this->_handle=0;
  this->_signum=0;
  this->_mask=0;
  this->_flags=0;
}
