/*
 *
 * Utilities for OpenRTM
 * Copyright(C) Isao Hara
 */

#ifndef __RTC_UTIL__
#define __RTC_UTIL__

#include <string>
#include <vector>
#include <sys/types.h>
#include <regex.h>


class RTC_smatch{
public:
  std::string *_str;
  int _max;
  int _result;

public:
   RTC_smatch(int n=5);
   ~RTC_smatch();
   const char *str(int n);
};

class RTC_regex{
public:
  regex_t _pattern;

  RTC_regex(const char *pattern, int flag=REG_EXTENDED);
  RTC_regex(std::string str, int flag=REG_EXTENDED);
   ~RTC_regex();
};

bool regex_match(std::string& cline, RTC_smatch& results, RTC_regex& preg);
bool regex_split(std::back_insert_iterator<std::vector<std::string> > out,
		std::string& str, RTC_regex& preg);
int itoa(int n, char *str, int dx);

#endif
